<?
/**
 * @package MQTT
 * @author Akash Heimlich
 * @description MQTT Message enpoint management
 */
 
// this will take care of the package management functions and call the right function based on the get parameters

    include("/app/package.inc"); 
    
    function MQTT2_install($val) {
        MQTT2_enable();
        return 1;
    }
     
    function MQTT2_uninstall() {
        setPackageStatus("MQTT2",0);
        return 1;
    }
    
    function MQTT2_enable() {
        setPackageStatus("MQTT2",2);
        return 1;
    }
    
    function MQTT2_disable() {
        setPackageStatus("MQTT2",3);
        return 1;
    }
    
    function MQTT2_status() {
        $MQTT2_enabled=ini_get("/config/mqtt.ini","config","enabled",0);
        if (!$MQTT2_enabled) {
            return "MQTT is not enabled.";
        }
        if ($_GLOBALS['MQTT2_connected']) {
            return "MQTT is enabled and connected to the server";
        }
        return "MQTT is enabled but not connected to the server";
    }
    /* this is called at system boot */
    function MQTT2_init() {
        
        $MQTT2_enabled=ini_get("/config/mqtt.ini","config","enabled",0);
        $_GLOBALS['MQTT2_debug']=ini_get("/config/mqtt.ini","config","debug",0);

        /**
         * Install the widget in the control panel using this
         **/
        $arr=array();
        $arr['script']='/package/MQTT2.cgi?action=configure';
        $arr['title']='MQTT2';
        $arr['icon']='icon-hdd';
        $arr['desc']='MQTT settings';
        
		if (!$_GLOBALS['hooks']) 
			$_GLOBALS['hooks']=array();

		if (!$_GLOBALS['hooks']['menu']) 
			$_GLOBALS['hooks']['menu']=array();

		// add this to the sidebar

		$item=array();
		$item['link']='/package/MQTT2.cgi?action=configure';
		$item['title']='Configure MQTT 2';
		$item['icon']='fa-handshake';
		$_GLOBALS['hooks']['menu']['mqtt2']=$item;
		$a=array();

        $a['html']='<span data-bs-toggle="tooltip" data-bs-placement="bottom" title="MQTT connection active. Transmitted {{livedata.MQTT2_tx}} messages. Received {{livedata.MQTT2_rx}} messages.">'+
    '<i ng-show="livedata.mqtt==1" class="align-middle fas fa-handshake"></i></span>'+
    '<span data-bs-toggle="tooltip" data-bs-placement="bottom" title="Wattmon is not to connected on MQTT.">'+
    '<i ng-show="livedata.mqtt!=1" class="align-middle fas fa-hand-scissors"></i></span>';

        if (!is_array($_GLOBALS['hooks']['topbar']))
            $_GLOBALS['hooks']['topbar']=array();
            
        $_GLOBALS['hooks']['topbar']['mqtt']=$a;


		$item=array();
        $item['ajax']=0;
        $item['advanced']=1;
        $item['link']='javascript:show_MQTT2_log(1)';
        $item['title']='Show MQTT Log';
        $_GLOBALS['hooks']['usermenu']['items'][]=$item;
        
         if (!is_array($_GLOBALS['hooks']['footer']))
            $_GLOBALS['hooks']['footer']=array();
        $_GLOBALS['hooks']['footer']['mqtt']='/package/mqtt/MQTT2Footer.inc';   
        
        $_GLOBALS['hooks']['cpanel'][]=$arr;
        
        // generate ajax data for front end processing
        if (file_exists('/package/mqtt2/MQTT2Ajax.inc')) 
            $_GLOBALS['hooks']['ajax'][]='/package/mqtt2/MQTT2Ajax.inc';

        // runs this file once a second
        if (file_exists('/package/mqtt2/MQTT2Sec.inc')) 
            $_GLOBALS['hooks']['sec'][]='/package/mqtt/MQTT2Sec.inc';
            
        // runs this file once a minute
        if (file_exists('/package/mqtt/MQTT2Min.inc')) 
            $_GLOBALS['hooks']['min'][]='/package/mqtt2/MQTT2Min.inc';
            
        // runs this file once a day
        if (file_exists('/package/mqtt/MQTT2Day.inc')) 
            $_GLOBALS['hooks']['sec'][]='/package/mqtt2/MQTT2Day.inc';            
            
        return 1;
    }
    
    function MQTT2_configure() {
        include("/app/config.inc");
        $bodyid='rootscope';
        $angular_controller="MQTT2"; 
        $config_file="mqtt.ini";
        $config_section="config";
        $rev=ini_get("/package/MQTT2.ini","package","version","");
        $title='MQTT2 '.($rev).'<small> Configuration Settings</small>';
        $header_subtitle=MQTT2_status();
        include("/app/header.inc");
        print('<link href="'.$url_prefix.'/lib/fontawesome/css/font-awesome.css" rel="stylesheet">');
        ?> 
<link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
<script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
<div class="alert alert-secondary" ng-cloak ng-show="loading"><i id='iconRepeatMain' class='icon-spinner icon-spin' style='font-size:36px; color:red'></i>&nbsp;<? print(lang('PLEASE_WAIT','deviceedit')) ?></div>

<form id="form" name="form" class="css-form">

<div ng-init="mqtt_dynamic_buffer_size=<? print(ini_get("/config/mqtt.ini","config","mqtt_dynamic_buffer_size",0)); ?>;"></div>
<div ng-init="mqtt_max_packet_size=<? print(ini_get("/config/mqtt.ini","config","mqtt_max_packet_size",8000)); ?>;"></div>

<div ng-init="enabled=<? print(ini_get("/config/mqtt.ini","config","enabled",0)); ?>;"></div>
<div ng-init="app=<? print(ini_get("/config/mqtt.ini","config","app",0)); ?>;"></div>
<div ng-init="mqtt_secure=<? print(ini_get("/config/mqtt.ini","config","mqtt_secure",0)); ?>;"></div>
<div ng-init="mqtt_port=<? print(ini_get("/config/mqtt.ini","config","mqtt_port",1883)); ?>;"></div>
<div ng-init="mqtt_server='<? print(ini_get("/config/mqtt.ini","config","mqtt_server","")); ?>';"></div>
<div ng-init="mqtt_user='<? print(ini_get("/config/mqtt.ini","config","mqtt_user","")); ?>';"></div>
<div ng-init="mqtt_password='<? print(ini_get("/config/mqtt.ini","config","mqtt_password","")); ?>';"></div>
<div ng-init="mqtt_cert='<? print(ini_get("/config/mqtt.ini","config","mqtt_cert","")); ?>';"></div>
<div ng-init="mqtt_private_key='<? print(ini_get("/config/mqtt.ini","config","mqtt_private_key","")); ?>';"></div>
<div ng-init="mqtt_keepalive=<? print(ini_get("/config/mqtt.ini","config","mqtt_keepalive",60)); ?>;"></div>
<div ng-init="mqtt_timeout=<? print(ini_get("/config/mqtt.ini","config","mqtt_timeout",30)); ?>;"></div>
<div ng-init="mqtt_protocol=<? print(ini_get("/config/mqtt.ini","config","mqtt_protocol",311)); ?>;"></div>
<div ng-init="mqtt_id='<? print(ini_get("/config/mqtt.ini","config","mqtt_id",getmac())); ?>';"></div>
<div ng-init="autopublish=<? print(ini_get("/config/mqtt.ini","config","autopublish",0)); ?>;"></div>
<div ng-init="autosubscribe=<? print(ini_get("/config/mqtt.ini","config","autosubscribe",0)); ?>;"></div>

<div ng-init="enabled2=<? print(ini_get("/config/mqtt.ini","config","enabled2",0)); ?>;"></div>
<div ng-init="app2=<? print(ini_get("/config/mqtt.ini","config","app2",0)); ?>;"></div>
<div ng-init="mqtt_secure2=<? print(ini_get("/config/mqtt.ini","config","mqtt_secure2",0)); ?>;"></div>
<div ng-init="mqtt_port2=<? print(ini_get("/config/mqtt.ini","config","mqtt_port2",1883)); ?>;"></div>
<div ng-init="mqtt_server2='<? print(ini_get("/config/mqtt.ini","config","mqtt_server2","")); ?>';"></div>
<div ng-init="mqtt_user2='<? print(ini_get("/config/mqtt.ini","config","mqtt_user2","")); ?>';"></div>
<div ng-init="mqtt_password2='<? print(ini_get("/config/mqtt.ini","config","mqtt_password2","")); ?>';"></div>
<div ng-init="mqtt_cert2='<? print(ini_get("/config/mqtt.ini","config","mqtt_cert2","")); ?>';"></div>
<div ng-init="mqtt_private_key2='<? print(ini_get("/config/mqtt.ini","config","mqtt_private_key2","")); ?>';"></div>
<div ng-init="mqtt_keepalive2=<? print(ini_get("/config/mqtt.ini","config","mqtt_keepalive2",60)); ?>;"></div>
<div ng-init="mqtt_timeout2=<? print(ini_get("/config/mqtt.ini","config","mqtt_timeout2",30)); ?>;"></div>
<div ng-init="mqtt_protocol2=<? print(ini_get("/config/mqtt.ini","config","mqtt_protocol2",311)); ?>;"></div>
<div ng-init="mqtt_id2='<? print(ini_get("/config/mqtt.ini","config","mqtt_id2",getmac())); ?>';"></div>
<div ng-init="autopublish2=<? print(ini_get("/config/mqtt.ini","config","autopublish2",0)); ?>;"></div>
<div ng-init="autosubscribe2=<? print(ini_get("/config/mqtt.ini","config","autosubscribe2",0)); ?>;"></div>


<div ng-init="debug=<? print(ini_get("/config/mqtt.ini","config","debug",0)); ?>;"></div>

<div class="row">

    <div class="col-md-12 col-xl-12">
        <div class="tab-content">
            <div class="tab-pane fade show active" id="account" role="tabpanel">        
            
                <div class="card">
                        <div class="card-body">
                            <div class="py-2 border-bottom d-lg-block">
									<div class="d-flex align-items-center py-1">
										<div class="flex-grow-1 ps-3">
											<h5>Global MQTT Options</h5>
										</div>
									</div>
								</div>
                        
                            <p class="card-text">

                            <div class="alert alert-success alert-dismissible" role="alert" ng-cloak ng-show="successmsg">
                                <div class="alert-message">
                                    {{successmsg}}
                                </div>

                            </div>
                            <div class="alert alert-danger alert-dismissible" role="alert" ng-cloak ng-show="errormsg">
                                <div class="alert-message">
                                    {{errormsg}}
                                </div>

                            </div>

            	            <div class="mb-3 row">
                                <label for="debug" class="col-form-label col-sm-2 text-sm-end pt-sm-0">Debug Mode</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="debug" id="debug1" value="0">
                                        <label class="form-check-label" for="debug1">
                                            &nbsp;<? print(lang('DISABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="debug" id="debug2" value="1">
                                        <label class="form-check-label" for="debug2">
                                            &nbsp;<? print(lang('ENABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <small id="dnHelp" class="form-text text-muted">MQTT debug mode (to log file)</small>
                                </div>
                                
                            </div>
            	            <div class="mb-3 row">
                                <label for="debug" class="col-form-label col-sm-2 text-sm-end pt-sm-0">Dynamic Buffer Sizing</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_dynamic_buffer_size" id="mqtt_dynamic_buffer_size1" value="0">
                                        <label class="form-check-label" for="mqtt_dynamic_buffer_size1">
                                            &nbsp;Disabled
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_dynamic_buffer_size" id="mqtt_dynamic_buffer_size2" value="1">
                                        <label class="form-check-label" for="mqtt_dynamic_buffer_size2">
                                            &nbsp;Enabled
                                        </label>
                                    </div>
                                    <small id="dnHelp" class="form-text text-muted">Resize the TX buffer dynamically to accommodate larger packets</small>
                                </div>
                                
                            </div>
                            
                            <div class="mb-3 row">
                                <label class="col-form-label col-sm-2 text-sm-end">Maximum TX Packet Size</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_max_packet_size" size='6' integer minval="10" maxval="65535" ng-model="mqtt_max_packet_size" aria-describedby="buserHelp" placeholder="MQTT Maximum Packet Size">
                                <div ng-cloak class='small text-danger' ng-show="form.mqtt_max_packet_size.$invalid"><strong>Max Packet Size</strong></div>
                                <small id="buserHelp" class="form-text text-muted">Max TX/RX Packet Size in bytes</small>
                                </div>
                            </div>
                            
<br/>        
	</p>
    </div>
</div>
            
                <div class="card">
                        <div class="card-body">
                            <div class="py-2 border-bottom d-lg-block">
									<div class="d-flex align-items-center py-1">
										<div class="flex-grow-1 ps-3">
											<h5>MQTT Server 1</h5>
										</div>
									</div>
								</div>
                        
                            <p class="card-text">

                            <div class="mb-3 row">
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">MQTT Status</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="enabled" id="exampleRadios2" value="0">
                                        <label class="form-check-label" for="exampleRadios2">
                                            &nbsp;<? print(lang('DISABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="enabled" id="exampleRadios3" value="1">
                                        <label class="form-check-label" for="exampleRadios3">
                                            &nbsp;<? print(lang('ENABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">MQTT engine status</small>
                                </div>
                            </div>
			                <div class="mb-3 row" ng-show='enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Server</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_server" ng-model="mqtt_server" aria-describedby="buserHelp" placeholder="MQTT Server">
                                <small id="buserHelp" class="form-text text-muted">MQTT Server host name</small>
                                <small ng-cloak class='text-danger' ng-show="form.mqtt_server.$invalid">Invalid server name</small>
                                </div>

                            </div>
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Port</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_port" size='4' integer minval="10" maxval="65535" ng-model="mqtt_port" aria-describedby="buserHelp" placeholder="MQTT Port Number">
                                <div ng-cloak class='small text-danger' ng-show="form.mqtt_port.$invalid"><strong>Invalid Port Number</strong></div>
                                <small id="buserHelp" class="form-text text-muted">Enter Server Port number</small>
                                </div>

                            </div>
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">Use TLS Encryption</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_secure" id="enabled3" value="0">
                                        <label class="form-check-label" for="enabled3">
                                            &nbsp;<? print(lang('DISABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_secure" id="enabled4" value="1">
                                        <label class="form-check-label" for="enabled4">
                                            &nbsp;<? print(lang('ENABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">TLS Encryption status</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='mqtt_secure==1 && enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">TLS Custom Cert File Path</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_cert" ng-model="mqtt_cert" aria-describedby="buserHelp" placeholder="MQTT CERT file">
                                <small id="buserHelp" class="form-text text-muted">Custom .pem.crt /path/to/file (if any) for the certificate - leave blank if not required</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='mqtt_secure==1 && enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">TLS Custom Cert File Path</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_private_key" ng-model="mqtt_private_key" aria-describedby="buserHelp" placeholder="MQTT KEY file">
                                <small id="buserHelp" class="form-text text-muted">Custom .key /path/to/file (if any) for the private ke - leave blank if not required</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Username</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_user" ng-model="mqtt_user" aria-describedby="buserHelp" placeholder="MQTT Username">
                                     <small id="dnHelp" class="form-text text-muted">MQTT Username - leave blank if not required</small>
                                    <small ng-cloak class='text-danger' ng-show="form.mqtt_user.$invalid">Invalid user name</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Password</label>
                                <div class="col-sm-10">
                                    <input type='password' class="form-control" id="mqtt_password" ng-model="mqtt_password" aria-describedby="buserHelp" placeholder="MQTT Password">
                                     <small id="dnHelp" class="form-text text-muted">MQTT Password - leave blank if not required</small>
                                    <small ng-cloak class='text-danger' ng-show="form.mqtt_password.$invalid">Invalid Password</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">MQTT Mode</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="app" id="app_mode1" value="0">
                                        <label class="form-check-label" for="app_mode1">
                                            &nbsp;User Mode
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="app" id="app_mode2" value="1">
                                        <label class="form-check-label" for="app_mode2">
                                            &nbsp;App Mode
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">Select App mode if using this channel with automatic firmware functionality and user mode if you plan to manually process incoming and outgoing messages through scripts</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Connect ID</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_id" ng-model="mqtt_id" aria-describedby="buserHelp" placeholder="MQTT Connect ID">
                                     <small id="dnHelp" class="form-text text-muted">MQTT Connect ID - needs to be unique per MQTT server</small>
                                    <small ng-cloak class='text-danger' ng-show="form.mqtt_id.$invalid">Invalid connect id</small>
                                </div>
                            </div>
                            
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">MQTT Protocol</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_protocol" id="mqtt_protocol1" value="3">
                                        <label class="form-check-label" for="mqtt_protocol1">
                                            &nbsp;MQTT 3
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_protocol" id="mqtt_protocol2" value="311">
                                        <label class="form-check-label" for="mqtt_protocol2">
                                            &nbsp;MQTT 3.1
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">Select the MQTT Protocol you wish to use</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">Timeout</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_timeout" size='3' integer minval="1" maxval="65535" ng-model="mqtt_timeout" aria-describedby="buserHelp" placeholder="MQTT command timeout in seconds">
                                <div ng-cloak class='small text-danger' ng-show="form.mqtt_timeout.$invalid"><strong>Timeout</strong></div>
                                <small id="buserHelp" class="form-text text-muted">MQTT Command timeout in seconds</small>
                                </div>
                            </div>
                            <div class="mb-3 row"ng-show='enabled==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">Keepalive</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_keepalive" size='5' integer minval="1" maxval="65535" ng-model="mqtt_keepalive" aria-describedby="buserHelp" placeholder="MQTT keepalive interval in seconds">
                                <div ng-cloak class='small text-danger' ng-show="form.mqtt_keepalive.$invalid"><strong>Timeout</strong></div>
                                <small id="buserHelp" class="form-text text-muted">MQTT Keepalive time (to send PINGs)</small>
                                </div>
                            </div>

		
            
    
                            <br/>
                            <div class="card" ng-show='enabled==1'>
                                <div class="card-body">
                                    <h5 class="card-title">MQTT Automatic Device Data Publishing</h5>
                                    <p class="card-text">
                                        <div style='float:right'><a name='ot_addact'></a>
                                            <button class="btn btn-large" ng-click="doAdd(autopublish_items)">Add Device</button>
                                        </div>
                                        <div class='clearfix'></div>
                                        <table class='table table-striped'>
                                            <tr>
                                                <th scope="col"></th>
                                                <th scope="col">Device ID</th>
                                                <th scope="col">Channel</th>
                                                <th scope="col">Interval</th>
                                                <th scope="col">Options</th>
                                            </tr>
                                            
                                            <tr ng-repeat="item in autopublish_items">
                                                <td><a name='ot{{$index}}'></a><span class="badge badge-pill badge-dark">{{$index}}</span></td>
                                                <td><div>
                                                    <select ng-model="item.device_id"  required name='dev{{item.device_id}}' class="form-control">
                                    	                <? $num_dev=mb_num_devices(); 
                                    	                for ($i=0;$i<$num_dev;$i++) {
                                    	                    $d=mb_get_dev_by_index($i);
                                    	                    print("<option value=".$d['slave_id'].">".$d['name'].'</option>');
                                    	                } 
                                    	                ?>
                                    	            </select>

                                                    </div></td>    
                                                <td><div>
                                                    <input class='form-control' type='text' ng-model='item.channel'>
                                                    </div></td>            
                                                    
                                                <td><div>
                                                    <input class='form-control' type='text' ng-model='item.interval'>
                                                    </div></td>            
                                                 <td>
                                                    <div ng-hide="refresh" class="dropdown">
                                                            <button class="btn btn-secondary dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                                <? print(lang('ACTION','devicetypeedit')) ?> <span class="caret"></span>
                                                            </button>
                                                    
                                                            <div class="dropdown-menu dropdown-menu-right text-dark" >
                                                                <a class="dropdown-item" ng-click='deleteItem(autopublish_items,$index)' href='#ot_addact'><i class="icon-remove"></i>&nbsp;<? print(lang('DELETE','devicetypeedit')) ?></a>
                                                            </div>
                                                        </div>
                                                </td>    
                                            </tr>
                                        </table>

                                    </p>
                                </div>
                            </div>
                            <br/>
                            <div class="card" ng-show='enabled==1'>
                                <div class="card-body">
                                    <h5 class="card-title">MQTT Subscribed Channels</h5>
                                    <p class="card-text">
                                        <div style='float:right'><a name='sub_addact'></a>
                                            <button class="btn btn-large" ng-click="doAdd(autosubscribe_items)">Add Channel</button>
                                        </div>
                                        <div class='clearfix'></div>
                                        <table class='table table-striped'>
                                            <tr>
                                                <th scope="col"></th>
                                                <th scope="col">Channel</th>
                                                <th scope="col">Callback</th>
                                                <th scope="col">Options</th>
                                            </tr>
                                            <tr ng-show='app==1'>
                                                <td></td>
                                                <td>/{{mqtt_id}}/app2wm/#</td>
                                                <td>Automatically Handled in Firmware</td>
                                                <td></td>
                                            </tr>
                                            <tr ng-repeat="item in autosubscribe_items">
                                                <td><a name='ot{{$index}}'></a><span class="badge badge-pill badge-dark">{{$index}}</span></td>
                                                <td><div>
                                                    <input class='form-control' type='text' ng-model='item.channel'>
                                                </div></td>            
                                                <td><div ng-show='app==0'>
                                                    <input class='form-control' type='text' ng-model='item.script'>
                                                </div><div ng-show='app==1'>
                                                    Automatically Handled in Firmware
                                                </div></td>            
                                                <td>    
                                                    <div ng-hide="refresh" class="dropdown">
                                                            <button class="btn btn-secondary dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                                <? print(lang('ACTION','devicetypeedit')) ?> <span class="caret"></span>
                                                            </button>
                                                    
                                                            <div class="dropdown-menu dropdown-menu-right text-dark" >
                                                                <a class="dropdown-item" ng-click='deleteItem(autosubscribe_items,$index)' href='#ot_addact'><i class="icon-remove"></i>&nbsp;<? print(lang('DELETE','devicetypeedit')) ?></a>
                                                            </div>
                                                        </div>
                                                </td>    
                                            </tr>
                                        </table>

                                    </p>
                                </div>
                            </div>

                            <br/>
                
                    	</p>
                    </div>
                </div>

                <div class="card">
                    <div class="card-body">
                        <div class="py-2 border-bottom d-lg-block">
								<div class="d-flex align-items-center py-1">
									<div class="flex-grow-1 ps-3">
										<h5>MQTT Server 2</h5>
									</div>
								</div>
							</div>
                    
                            <p class="card-text">
                            <div class="mb-3 row">
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">MQTT Status</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="enabled2" id="exampleRadios22" value="0">
                                        <label class="form-check-label" for="exampleRadios22">
                                            &nbsp;<? print(lang('DISABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="enabled2" id="exampleRadios23" value="1">
                                        <label class="form-check-label" for="exampleRadios23">
                                            &nbsp;<? print(lang('ENABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">MQTT engine status</small>
                                </div>
                            </div>
			                <div class="mb-3 row" ng-show='enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Server</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_server2" ng-model="mqtt_server2" aria-describedby="buserHelp" placeholder="MQTT Server">
                                <small id="buserHelp" class="form-text text-muted">MQTT Server host name</small>
                                <small ng-cloak class='text-danger' ng-show="form.mqtt_server2.$invalid">Invalid server name</small>
                                </div>

                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Port</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_port2" size='4' integer minval="10" maxval="65535" ng-model="mqtt_port2" aria-describedby="buserHelp" placeholder="MQTT Port Number">
                                <div ng-cloak class='small text-danger' ng-show="form.mqtt_port2.$invalid"><strong>Invalid Port Number</strong></div>
                                <small id="buserHelp" class="form-text text-muted">Enter Server Port number</small>
                                </div>

                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">Use TLS Encryption</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_secure2" id="enabled23" value="0">
                                        <label class="form-check-label" for="enabled23">
                                            &nbsp;<? print(lang('DISABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_secure2" id="enabled24" value="1">
                                        <label class="form-check-label" for="enabled24">
                                            &nbsp;<? print(lang('ENABLED','network3g')) ?>
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">TLS Encryption status</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='mqtt_secure2==1 && enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">TLS Custom Cert File Path</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_cert2" ng-model="mqtt_cert2" aria-describedby="buserHelp" placeholder="MQTT CERT file">
                                <small id="buserHelp" class="form-text text-muted">Custom .pem.crt /path/to/file (if any) for the certificate - leave blank if not required</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='mqtt_secure2==1 && enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">TLS Custom Cert File Path</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_private_key2" ng-model="mqtt_private_key2" aria-describedby="buserHelp" placeholder="MQTT KEY file">
                                <small id="buserHelp" class="form-text text-muted">Custom .key /path/to/file (if any) for the private ke - leave blank if not required</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Username</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_user2" ng-model="mqtt_user2" aria-describedby="buserHelp" placeholder="MQTT Username">
                                     <small id="dnHelp" class="form-text text-muted">MQTT Username - leave blank if not required</small>
                                    <small ng-cloak class='text-danger' ng-show="form.mqtt_user2.$invalid">Invalid user name</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Password</label>
                                <div class="col-sm-10">
                                    <input type='password' class="form-control" id="mqtt_password2" ng-model="mqtt_password2" aria-describedby="buserHelp" placeholder="MQTT Password">
                                     <small id="dnHelp" class="form-text text-muted">MQTT Password - leave blank if not required</small>
                                    <small ng-cloak class='text-danger' ng-show="form.mqtt_password2.$invalid">Invalid Password</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">MQTT Mode</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="app2" id="app_mode21" value="0">
                                        <label class="form-check-label" for="app_mode21">
                                            &nbsp;User Mode
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="app2" id="app_mode22" value="1">
                                        <label class="form-check-label" for="app_mode22">
                                            &nbsp;App Mode
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">Select App mode if using this channel with automatic firmware functionality and user mode if you plan to manually process incoming and outgoing messages through scripts</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">MQTT Connect ID</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_id2" ng-model="mqtt_id2" aria-describedby="buserHelp" placeholder="MQTT Connect ID">
                                     <small id="dnHelp" class="form-text text-muted">MQTT Connect ID - needs to be unique per MQTT server</small>
                                    <small ng-cloak class='text-danger' ng-show="form.mqtt_id2.$invalid">Invalid connect id</small>
                                </div>
                            </div>
                            
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label for="enabled" class="col-form-label col-sm-2 text-sm-end pt-sm-0">MQTT Protocol</label>
                                <div class="col-sm-10">
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_protocol2" id="mqtt_protocol21" value="3">
                                        <label class="form-check-label" for="mqtt_protocol21">
                                            &nbsp;MQTT 3
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="radio" ng-model="mqtt_protocol" id="mqtt_protocol22" value="311">
                                        <label class="form-check-label" for="mqtt_protocol22">
                                            &nbsp;MQTT 3.1
                                        </label>
                                    </div>
                                    <small id="ddHelp" class="form-text text-muted">Select the MQTT Protocol you wish to use</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">Timeout</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_timeout2" size='3' integer minval="1" maxval="65535" ng-model="mqtt_timeout2" aria-describedby="buserHelp" placeholder="MQTT command timeout in seconds">
                                <div ng-cloak class='small text-danger' ng-show="form.mqtt_timeout2.$invalid"><strong>Timeout</strong></div>
                                <small id="buserHelp" class="form-text text-muted">MQTT Command timeout in seconds</small>
                                </div>
                            </div>
                            <div class="mb-3 row" ng-show='enabled2==1'>
                                <label class="col-form-label col-sm-2 text-sm-end">Keepalive</label>
                                <div class="col-sm-10">
                                    <input type='text' class="form-control" id="mqtt_keepalive2" size='5' integer minval="1" maxval="65535" ng-model="mqtt_keepalive2" aria-describedby="buserHelp" placeholder="MQTT keepalive interval in seconds">
                                <div ng-cloak class='small text-danger' ng-show="form.mqtt_keepalive2.$invalid"><strong>Timeout</strong></div>
                                <small id="buserHelp" class="form-text text-muted">MQTT Keepalive time (to send PINGs)</small>
                                </div>
                            </div>

		
            
    
                            <br/>
                            <div class="card" ng-show='enabled2==1'>
                                <div class="card-body">
                                    <h5 class="card-title">MQTT Automatic Device Data Publishing</h5>
                                    <p class="card-text">
                                        <div style='float:right'><a name='ot3_addact'></a>
                                            <button class="btn btn-large" ng-click="doAdd(autopublish2_items)">Add Device</button>
                                        </div>
                                        <div class='clearfix'></div>
                                        <table class='table table-striped'>
                                            <tr>
                                                <th scope="col"></th>
                                                <th scope="col">Device ID</th>
                                                <th scope="col">Channel</th>
                                                <th scope="col">Interval</th>
                                                <th scope="col">Options</th>
                                            </tr>
                                            
                                            <tr ng-repeat="item in autopublish2_items">
                                                <td><a name='ot{{$index}}'></a><span class="badge badge-pill badge-dark">{{$index}}</span></td>
                                                <td><div>
                                                    <select ng-model="item.device_id"  required name='dev{{item.device_id}}' class="form-control">
                                    	                <? $num_dev=mb_num_devices(); 
                                    	                for ($i=0;$i<$num_dev;$i++) {
                                    	                    $d=mb_get_dev_by_index($i);
                                    	                    print("<option value=".$d['slave_id'].">".$d['name'].'</option>');
                                    	                } 
                                    	                ?>
                                    	            </select>

                                                    </div></td>    
                                                <td><div>
                                                    <input class='form-control' type='text' ng-model='item.channel'>
                                                    </div></td>            
                                                    
                                                <td><div>
                                                    <input class='form-control' type='text' ng-model='item.interval'>
                                                    </div></td>            
                                                 <td>
                                                    <div ng-hide="refresh" class="dropdown">
                                                            <button class="btn btn-secondary dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                                <? print(lang('ACTION','devicetypeedit')) ?> <span class="caret"></span>
                                                            </button>
                                                    
                                                            <div class="dropdown-menu dropdown-menu-right text-dark" >
                                                                <a class="dropdown-item" ng-click='deleteItem(autopublish2_items,$index)' href='#ot_addact'><i class="icon-remove"></i>&nbsp;<? print(lang('DELETE','devicetypeedit')) ?></a>
                                                            </div>
                                                        </div>
                                                </td>    
                                            </tr>
                                        </table>

                                    </p>
                                </div>
                            </div>
                            <br/>
                            <div class="card" ng-show='enabled2==1'>
                                <div class="card-body">
                                    <h5 class="card-title">MQTT Subscribed Channels</h5>
                                    <p class="card-text">
                                        <div style='float:right'><a name='sub2_addact'></a>
                                            <button class="btn btn-large" ng-click="doAdd(autosubscribe2_items)">Add Channel</button>
                                        </div>
                                        <div class='clearfix'></div>
                                        <table class='table table-striped'>
                                            <tr>
                                                <th scope="col"></th>
                                                <th scope="col">Channel</th>
                                                <th scope="col">Callback</th>
                                                <th scope="col">Options</th>
                                            </tr>
                                            <tr ng-show='app2==1'>
                                                <td></td>
                                                <td>/{{mqtt_id2}}/app2wm/#</td>
                                                <td>Automatically Handled in Firmware</td>
                                                <td></td>
                                            </tr>
                                            <tr ng-repeat="item in autosubscribe2_items">
                                                <td><a name='ot{{$index}}'></a><span class="badge badge-pill badge-dark">{{$index}}</span></td>
                                                <td><div>
                                                    <input class='form-control' type='text' ng-model='item.channel'>
                                                </div></td>            
                                                <td><div ng-show='app2==0'>
                                                    <input class='form-control' type='text' ng-model='item.script'>
                                                </div><div ng-show='app2==1'>
                                                    Automatically Handled in Firmware
                                                </div></td>            
                                                <td>    
                                                    <div ng-hide="refresh" class="dropdown">
                                                            <button class="btn btn-secondary dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                                <? print(lang('ACTION','devicetypeedit')) ?> <span class="caret"></span>
                                                            </button>
                                                    
                                                            <div class="dropdown-menu dropdown-menu-right text-dark" >
                                                                <a class="dropdown-item" ng-click='deleteItem(autosubscribe2_items,$index)' href='#ot_addact'><i class="icon-remove"></i>&nbsp;<? print(lang('DELETE','devicetypeedit')) ?></a>
                                                            </div>
                                                        </div>
                                                </td>    
                                            </tr>
                                        </table>

                                    </p>
                                </div>
                            </div>

                            <br/>                            
                            <br/>        
                        </p>
                    </div>
                </div>
                <div class="mb-3 row">
					<div class="col-sm-10 ms-sm-auto">
                        <button class="btn btn-primary" ng-hide='loading==1'  ng-click="saveSettings()"><? print(lang('APPLY','deviceedit')) ?></button>
                    </div>
                </div>
                <div class="alert alert-success alert-dismissible" role="alert" ng-cloak ng-show="successmsg">
                    <div class="alert-message">
                        {{successmsg}}
                    </div>

                </div>
                <div class="alert alert-danger alert-dismissible" role="alert" ng-cloak ng-show="errormsg">
                    <div class="alert-message">
                        {{errormsg}}
                    </div>

                </div>
                            
                            
        <script>
var gItems,gHttp;
var count=0;
var app = angular.module('myApp', []);

document.addEventListener("DOMContentLoaded", function() {
			// Select2
			$(".select2").each(function() {
				$(this)
					.wrap("<div class=\"position-relative\"></div>")
					.select2({
						placeholder: "Select value",
						dropdownParent: $(this).parent()
					});
			});
});
</script>
 <?
        include("/app/footer.inc");?>
<script>
function MQTT2($scope, $timeout,$http) {
   var self = this;
   $scope.autosubscribe_items=[
<? 
$autosubscribe = ini_get("/config/mqtt.ini","config","autosubscribe",0);

for ($i=0;$i<$autosubscribe;$i++) {
    if ($i) print(",");
    print("{\"channel\":\"".ini_get("/config/mqtt.ini","config","sub_topic".$i,"")."\"");
    print(",\"script\":\"".ini_get("/config/mqtt.ini","config","sub_script".$i,"")."\"}");
}

?>];

   $scope.autopublish_items=[
<? 
$autopublish = ini_get("/config/mqtt.ini","config","autopublish",0);

for ($i=0;$i<$autopublish;$i++) {
    if ($i) print(",");
    print("{\"channel\":\"".ini_get("/config/mqtt.ini","config","pub_topic".$i,"")."\"");
    print(",\"interval\":\"".ini_get("/config/mqtt.ini","config","pub_interval".$i,5)."\"");
    print(",\"device_id\":\"".ini_get("/config/mqtt.ini","config","pub_id".$i,5)."\"}");
}

?>];

   $scope.autosubscribe2_items=[
<? 
$autosubscribe = ini_get("/config/mqtt.ini","config","autosubscribe2",0);

for ($i=0;$i<$autosubscribe;$i++) {
    if ($i) print(",");
    print("{\"channel\":\"".ini_get("/config/mqtt.ini","config","sub2_topic".$i,"")."\"");
    print(",\"script\":\"".ini_get("/config/mqtt.ini","config","sub2_script".$i,"")."\"}");
}

?>];

   $scope.autopublish2_items=[
<? 
$autopublish = ini_get("/config/mqtt.ini","config","autopublish2",0);

for ($i=0;$i<$autopublish;$i++) {
    if ($i) print(",");
    print("{\"channel\":\"".ini_get("/config/mqtt.ini","config","pub2_topic".$i,"")."\"");
    print(",\"interval\":\"".ini_get("/config/mqtt.ini","config","pub2_interval".$i,5)."\"");
    print(",\"device_id\":\"".ini_get("/config/mqtt.ini","config","pub2_id".$i,5)."\"}");
}

?>];
   
   //alert('init');
   $scope.regexURL = $scope.regex = new RegExp('^((https?|ftp)://)?([a-z0-9]+[.])?[a-z0-9-]+([.][a-z]{1,4}){1,2}(/.*[?].*)?$', 'i');
   $scope.loading=0;
   $gscope=$scope;
   $scope.deviceList = [
   <? 
        $pubs=explode(ini_get("/config/mqtt.ini","config","publish_dev",""),",");
        
        $num_dev=mb_num_devices(); 
	                for ($i=0;$i<$num_dev;$i++) {
	                    $d=mb_get_dev_by_index($i);
	                    if ($i) print(",");
	                    $sel=0;
	                    
	                    for ($j=0;$j<sizeof($pubs);$j++) {
	                        
	                        if ($pubs[$j]==$i) $sel=1;
	                    }
	                    //print("sel=".$sel."\r\n");
	                    if ($sel) $sel="selected"; else $sel="";
	                    
	                    print("{\"sel\":\"".$sel."\",\"device_id\":".$i.",\"device_name\":\"".$d['name'].'"}');
	                } 
	               ?>
   ]

  $scope.doAdd=function(arr) {
    if (arr==$scope.autopublish_items) {
        $scope.autopublish++;$scope.autopublish_items.push({channel:"/"+$scope.mqtt_id+"/app2wm/device/tx/1",device_id:1,interval:5});
    }
    if (arr==$scope.autosubscribe_items) {
        $scope.autosubscribe++;$scope.autosubscribe_items.push({channel:"/"+$scope.mqtt_id+"/app2wm/#",callback:"/script/path.cgi"});
    }
    if (arr==$scope.autopublish2_items) {
        $scope.autopublish2++;$scope.autopublish2_items.push({channel:"/"+$scope.mqtt_id2+"/app2wm/device/tx/1",device_id:1,interval:5});
    }
    if (arr==$scope.autosubscribe2_items) {
        $scope.autosubscribe2++;$scope.autosubscribe2_items.push({channel:"/"+$scope.mqtt_id2+"/app2wm/#",callback:"/script/path.cgi"});
    }
    
  }
  
  $scope.deleteItem = function ( arr,idx ) {
    
    //API.DeleteAction({ id: person_to_delete.id }, function (success) {
     arr.splice(idx, 1);
     if (arr==$scope.autopublish_items) {
        $scope.autopublish--;
    }
     if (arr==$scope.autosubscribe_items) {
        $scope.autosubscribe--;
    }
     if (arr==$scope.autopublish2_items) {
        $scope.autopublish2--;
    }
     if (arr==$scope.autosubscribe2_items) {
        $scope.autosubscribe2--;
    }
    
  };

  
   $scope.canShowDevice=function() {
        if ($scope.subscribe_action==4) {
            if ($scope.MQTT2_subscribe.indexOf('#') !== -1) {
                return false;
            }
            return true;
        } else return false;
   }
   
    $scope.canShowDeviceHelp=function() {
        if ($scope.subscribe_action==4) {
            if ($scope.MQTT2_subscribe.indexOf('#') !== -1) {
                return true;
            }
            return false;
        } else return false;
   }
   $scope.saveSettings=function() {
   $scope.successmsg="";
   $scope.errormsg=""
       post_data="enabled="+$scope.enabled;
       post_data+="&app="+$scope.app;
       post_data+="&autopublish="+$scope.autopublish;
       post_data+="&autosubscribe="+$scope.autosubscribe;
       post_data+="&mqtt_id="+btoa(encodeURIComponent($scope.mqtt_id));
       post_data+="&mqtt_user="+btoa(encodeURIComponent($scope.mqtt_user));
       post_data+="&mqtt_server="+btoa(encodeURIComponent($scope.mqtt_server));
       post_data+="&mqtt_port="+$scope.mqtt_port;
       post_data+="&mqtt_secure="+$scope.mqtt_secure;
       post_data+="&mqtt_cert="+$scope.mqtt_cert;
       post_data+="&mqtt_private_key="+$scope.mqtt_private_key;
       post_data+="&mqtt_password="+btoa(encodeURIComponent($scope.mqtt_password));
       post_data+="&mqtt_keepalive="+$scope.mqtt_keepalive;
       post_data+="&mqtt_timeout="+$scope.mqtt_timeout;
       var idx=0;
       var encoded_keys="mqtt_id,mqtt_user,mqtt_server,mqtt_password";
       for (idx=0;idx<$scope.autopublish;idx++) {
            post_data+="&pub_id"+idx+"="+$scope.autopublish_items[idx].device_id;
            post_data+="&pub_interval"+idx+"="+$scope.autopublish_items[idx].interval;
            post_data+="&pub_topic"+idx+"="+btoa(encodeURIComponent($scope.autopublish_items[idx].channel));
            encoded_keys+=",pub_topic"+idx;
       }
       for (idx=0;idx<$scope.autosubscribe;idx++) {
            post_data+="&sub_topic"+idx+"="+btoa(encodeURIComponent($scope.autosubscribe_items[idx].channel));
            encoded_keys+=",sub_topic"+idx;
            post_data+="&sub_script"+idx+"="+btoa(encodeURIComponent($scope.autosubscribe_items[idx].script));
            encoded_keys+=",sub_script"+idx;
       }

       post_data+="&enabled2="+$scope.enabled2;
       post_data+="&app2="+$scope.app2;
       post_data+="&autopublish2="+$scope.autopublish2;
       post_data+="&autosubscribe2="+$scope.autosubscribe2;
       post_data+="&mqtt_id2="+btoa(encodeURIComponent($scope.mqtt_id2));
       post_data+="&mqtt_user2="+btoa(encodeURIComponent($scope.mqtt_user2));
       post_data+="&mqtt_server2="+btoa(encodeURIComponent($scope.mqtt_server2));
       post_data+="&mqtt_port2="+$scope.mqtt_port2;
       post_data+="&mqtt_secure2="+$scope.mqtt_secure2;
       post_data+="&mqtt_cert2="+$scope.mqtt_cert2;
       post_data+="&mqtt_private_key2="+$scope.mqtt_private_key2;
       post_data+="&mqtt_password2="+btoa(encodeURIComponent($scope.mqtt_password2));
       post_data+="&mqtt_keepalive2="+$scope.mqtt_keepalive2;
       post_data+="&mqtt_timeout2="+$scope.mqtt_timeout2;
       encoded_keys+=",mqtt_id2,mqtt_user2,mqtt_server2,mqtt_password2";
       for (idx=0;idx<$scope.autopublish2;idx++) {
            post_data+="&pub2_id"+idx+"="+$scope.autopublish2_items[idx].device_id;
            post_data+="&pub2_interval"+idx+"="+$scope.autopublish2_items[idx].interval;
            post_data+="&pub2_topic"+idx+"="+btoa(encodeURIComponent($scope.autopublish2_items[idx].channel));
            encoded_keys+=",pub2_topic"+idx;
       }
       for (idx=0;idx<$scope.autosubscribe2;idx++) {
            post_data+="&sub2_topic"+idx+"="+btoa(encodeURIComponent($scope.autosubscribe2_items[idx].channel));
            encoded_keys+=",sub2_topic"+idx;
            post_data+="&sub2_script"+idx+"="+btoa(encodeURIComponent($scope.autosubscribe2_items[idx].script));
            encoded_keys+=",sub2_script"+idx;
       }
       
       post_data+="&debug="+$scope.debug;
       post_data+="&encoded_keys="+encoded_keys;
       post_config="mqtt.ini";
       post_section="config";
       $http.post('/app/configsave.cgi?config='+post_config+'&section='+post_section,post_data)
        .then(function (response) {
          var data = response.data; 
          $scope.successmsg=(Number(data.status)==1)?"Saved Settings":"Error Saving";
          $scope.errormsg=data.error;
          $scope.sysmsg=data.sysmsg;
          return data;
        }, function(reason) {
            $scope.errormsg="Error saving settings";
            $scope.successmsg="";
        });
   }
       
}
   </script>
   
       
    <?
        return 1;
    }
    execute(); // process the package and run the correct function
    
?>













